import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

public class Main 
{

   public static void main(String[] args)
   {
      try
      {
         // Plotter initialisieren
         Plotter plotter = new Plotter();
         // Properties initialisieren
         Properties prop = new Properties();
         // Property-Datei laden
         prop.load(new FileInputStream("config.properties"));
         // Mithilfe Java-Reflection Klasse suchen und laden
         Class<?> c_datenquelle = Class.forName(prop.getProperty("Datenquelle"));
         // Objekt dieser Klasse anlegen
         IDatenquelle datenquelle = (IDatenquelle) c_datenquelle.newInstance();
         // Per set-Methode des Plotters dieses Objekt setzen
         plotter.setDatenquelle(datenquelle);
         // plotten
         plotter.plot();
      } catch (FileNotFoundException e)
      {
         System.out.println("Propertiy konnte nicht gefunden werden!");
         e.printStackTrace();
      } catch (IOException e) {
         System.out.println("Fehler beim Einlesen der Property-Datei!");
         e.printStackTrace();
      } catch (ClassNotFoundException e) {
         System.out.println("Klasse konnte nicht gefunden werden!");
         e.printStackTrace();
      } catch (InstantiationException e) {
         System.out.println("Es konnte keine Instanz der Klasse angelegt werden!");
         e.printStackTrace();
      } catch (IllegalAccessException e) {
         System.out.println("Fehler beim Instanziieren der Klasse - Klasse oder Konstruktor nicht zugänglich!");
         e.printStackTrace();
      }
   }

}