package Services;

// Datei: Woerterbuch.java
import java.util.List;

public class Woerterbuch
{
   private WoerterbuchManager wm;
   
   // Konstruktor
   public Woerterbuch()
   {
      // erzeugt Instanz des WoerterbuchManagers als Singleton
      wm = WoerterbuchManager.gibInstanz();
      wm.ladeVorhandeneWoerterbuecher();
   }

   // Uebersetzt Eingabe in verschiedene Sprachen
   public String uebersetze (String wort, String sprache)
   {
      String uebersetztesWort = wm.gibUebersetzung (sprache, wort);
      if (!ueberpruefeWort(uebersetztesWort))
      {
         return "Fehler, Wort nicht im Woerterbuch vorhanden!";
      }
      return uebersetztesWort;
   }

   // Liste aller vorhandenen Woerterbuecher zurueckgeben
   public List<String> gibAlleWoerterbuecher()
   {
      return wm.gibAlleWoerterbuecher();
   }

   // Ueberprueft, ob das Wort im Woerterbuch vorhanden ist
   private boolean ueberpruefeWort (String wort)
   {
      boolean enthalten = true;

      if (wort == null) {
         enthalten = false;
      }
      return enthalten;
   }
}
