// Datei: Client.java
public class Client
{
   // Diese Referenzen koennen sowohl auf echte Server-Objekte
   // zeigen, aber auch auf Client-side Proxys
   IWetterDienst wetterServer;
   ITemperaturDienst temperaturServer;

   public void injectServices(IWetterDienst wds, 
                              ITemperaturDienst tds)
   {
      wetterServer = wds;
      temperaturServer = tds;
   }

   // Diese Methode stellt die eigentliche Client-Anwendung dar.
   // Es werden Wetter- und Temperaturdaten von den Servern 
   // abgefragt und ausgegeben. 
   public void druckeWetterdaten()
   {
      // Wetter und Temperatur fuer heute anfordern
      System.out.println();
      System.out.println ("Client: " +
              "Wetter und Temperatur fuer heute anfragen:");
      String wetterHeute = 
              wetterServer.erfrageWetter (Tag.Heute);
      Float temperaturHeute = 
              temperaturServer.erfrageTemperatur (Tag.Heute);
      System.out.println ("Heute gibt es " + wetterHeute 
              + " bei " + temperaturHeute + " Grad.");

      // Wetter und Temperatur fuer morgen anfordern
      System.out.println();
      System.out.println ("Client: " +
               "Wetter und Temperatur fuer morgen anfragen:");
      String wetterMorgen = 
               wetterServer.erfrageWetter(Tag.Morgen);
      Float temperaturMorgen = 
               temperaturServer.erfrageTemperatur(Tag.Morgen);
      System.out.println ("Morgen gibt es " + wetterMorgen
              + " bei " + temperaturMorgen+ " Grad.");
   }
}
